# -*- coding: utf-8 -*-
# pylint: disable=unused-import
"""reassembly packets and datagrams

`pcapkit.reassembly` bases on algorithms described in
[`RFC 815`](https://tools.ietf.org/html/rfc815),
implements datagram reassembly of IP and TCP packets.

"""
# Base Class for Reassembly
from pcapkit.reassembly.reassembly import Reassembly
from pcapkit.reassembly.ip import IP_Reassembly

# Reassembly for IP
from pcapkit.reassembly.ipv4 import IPv4_Reassembly
from pcapkit.reassembly.ipv6 import IPv6_Reassembly

# Reassembly for TCP
from pcapkit.reassembly.tcp import TCP_Reassembly

__all__ = [
    'IPv4_Reassembly', 'IPv6_Reassembly',   # IP Reassembly
    'TCP_Reassembly',                       # TCP Reassembly
]
